      subroutine addsubvbar (task)
c
c-----------------------------------------------------------------------
c  Define global data
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <fieldsbar.h>
#include <vertical.h>
#include <voldat.h>
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i,ip,j,k
      FLOAT 
     &              sumu,sumv,sumz
      character*(*) task
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
c-----------------------------------------------------------------------
c  Add barotropic component to velocity.
c-----------------------------------------------------------------------
c
      if (task.eq.'Add') then
         do 20, j = 1, jmt
         do 20, i = 1, imt
            ip = i + (j-1)*imt
            do 10, k = 1, km
#ifndef surfpress
               xu(ip,k) = xu(ip,k) + ubaro(i,j)
               xv(ip,k) = xv(ip,k) + vbaro(i,j)
#else
               xu(ip,k) = xu(ip,k) + ubaronew(i,j)
               xv(ip,k) = xv(ip,k) + vbaronew(i,j)
#endif
  10        continue
  20     continue
         return
      end if
c
c-----------------------------------------------------------------------
c  Remove barotropic component from velocity.
c-----------------------------------------------------------------------
c
      if (task.eq.'Subtract') then
         do 50, j = 1, jmt
         do 50, i = 1, imt
            ip   = i + (j-1)*imt
c
            sumu = xu(ip,1)*dzv(i,j,1)
            sumv = xv(ip,1)*dzv(i,j,1)
            sumz = dzv(i,j,1)
            do 30, k = 2, km
               sumu = sumu + xu(ip,k)*dzv(i,j,k)
               sumv = sumv + xv(ip,k)*dzv(i,j,k)
               sumz = sumz + dzv(i,j,k)
  30        continue
            sumu = sumu / sumz
            sumv = sumv / sumz
c
            do 40, k = 1, km
               xu(ip,k) = xu(ip,k) - sumu
               xv(ip,k) = xv(ip,k) - sumv
  40        continue
#ifdef retainfiltvbar
# ifndef surfpress
            ubaro(i,j) = sumu
            vbaro(i,j) = sumv
# else
            ubaronew(i,j) = sumu
            vbaronew(i,j) = sumv
# endif
#endif
  50     continue
      end if
c
      return
      end
