c
c=======================================================================
c  Include file "bndyrlx.h"
c=======================================================================
#ifndef rmdocinc
c
c  DVBRLX    V-grid Spatial e-folding scale for boundary relaxation.
c  TVBRLX    V-grid Temporal e-folding scale for boundary relaxation.
c  DTBRLX    T-grid Spatial e-folding scale for boundary relaxation.
c  TTBRLX    T-grid Temporal e-folding scale for boundary relaxation.
c  DCSFRC    Spatial e-folding scale for coastal friction.
c  TCSFRC    Temporal e-folding scale for coastal friction.
c  DBTFRC    Spatial e-folding scale for bottom friction.
c  TBTFRC    Temporal e-folding scale for bottom friction.
# ifdef bndy_rlx
#  ifndef sponge_uvsplit
c  VFACBRLX  Boundary relaxation cofficient at velocity points.
#  else
c  UFACBRLX  Zonal boundary relaxation cofficient at velocity points.
c  VFACBRLX  Meridional boundary relaxation cofficient at velocity points.
#  endif
c  U_0       Zonal velocity towards which solution is relaxed.
c  V_0       Meridional velocity towards which solution is relaxed.
c  TFACBRLX  Boundary relaxation cofficient at tracer points.
c  T_0       Tracer value towards which solution is relaxed.
#  ifdef sponge_timave
c  SPNGTSCL  Averaging time scale for sponging targets
c  SPNGTWT   Time weight for sponging targets history integral.
c  SPNGTP1W  Time weight for sponging targets new integral
#  endif
# endif
# ifdef cstfrc
c  FACCSFRC  Coastal friction cofficients.
# endif
# ifdef botfrc
c  FACBTFRC  Bottom friction cofficients.
# endif
c
c=======================================================================
#endif
c
      FLOAT
     &      dbtfrc,dcsfrc,dtbrlx,dvbrlx,spngtscl,tbtfrc,tcsfrc,ttbrlx,
     &      tvbrlx
# if defined sponge_timave & defined bndy_rlx
     &       ,spngtwt,spngtp1w
#  if defined smallpsdt & defined small5psdt
     &       ,bspngtwt,bspngtp1w
#  endif
# endif
#ifdef bndy_rlx
      FLOAT
     &      tfacbrlx(imt,jmt),t_0(imt,jmt,km,nt),u_0(imt,jmt,km),
     &      v_0(imt,jmt,km)
# ifndef sponge_uvsplit
     &      ,vfacbrlx(imt,jmt)
# else
     &      ,ufacbrlx(imt,jmt),vfacbrlx(imt,jmt)
# endif
#endif
#ifdef cstfrc
     &      ,faccsfrc(imt,jmt)
#endif
#ifdef botfrc
     &      ,facbtfrc(km)
# if defined smallpsdt & defined small5psdt
     &      ,fmnbtfrc(imt,jmt)
# endif
#endif
c
      common /bndyrlx/ dvbrlx,tvbrlx,dtbrlx,ttbrlx,dcsfrc,tcsfrc,dbtfrc,
     &                 tbtfrc

#ifdef bndy_rlx
     &                 ,u_0,v_0,tfacbrlx,t_0
# ifndef sponge_uvsplit
     &                 ,vfacbrlx
# else
     &                 ,ufacbrlx,vfacbrlx
# endif
# ifdef sponge_timave
     &                 ,spngtscl,spngtwt,spngtp1w
#  if defined smallpsdt & defined small5psdt
     &                 ,bspngtwt,bspngtp1w
#  endif
# endif
#endif
#ifdef cstfrc
     &                 ,faccsfrc
#endif
#ifdef botfrc
     &                 ,facbtfrc
# if defined smallpsdt & defined small5psdt
     &                 ,fmnbtfrc
# endif
#endif
c
