      subroutine clean_smldtps
c
c-----------------------------------------------------------------------
c  Define global data.
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <dtswap.h>
#include <fields.h>
#include <fieldsbar.h>
#include <fullwd.h>
#include <scalar.h>
#include <vertical.h>
#include <workspb.h>
#if defined smallpsdt3
# include <vertslabs.h>
#endif
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i,j,count
      character*6 cntstr
      FLOAT
     &      ttsecsave
#if defined surfpress & defined freesurf & defined smallpsdt2
     &        ,fx
#endif
#if defined smallpsdt3
     &           ,uf(imt,jmt),vf(imt,jmt),fac
#endif
      data count /0/
      save count
c
c-----------------------------------------------------------------------
c  Begin executable code.
c-----------------------------------------------------------------------
c
#if defined surfpress & defined freesurf & defined smallpsdt2
c-----------------------------------------------------------------------
c Construct barotropic advection terms.
c-----------------------------------------------------------------------
c
c      count = count + 1
c      write (cntstr,'(i6.6)') count
c      open (413, file='ubaradv'//cntstr//'.dat', status='unknown')
c      open (414, file='vbaradv'//cntstr//'.dat', status='unknown')
c      open (415, file='detavadv'//cntstr//'.dat', status='unknown')
c      open (416, file='detatadv'//cntstr//'.dat', status='unknown')
c
      do 10, j = 1, jmt
      do 10, i = 1, imt
          fx            = p5*fracvb(i,j)/fracv(i,j)
          ubaradv(i,j)  = fx*(ubaro(i,j)+ubarob(i,j))
          vbaradv(i,j)  = fx*(vbaro(i,j)+vbarob(i,j))
          detavadv(i,j) = detav(i,j)
          detatadv(i,j) = detat(i,j)
c          write (413,*) ubaradv(i,j)
c          write (414,*) vbaradv(i,j)
c          write (415,*) detavadv(i,j)
c          write (416,*) detatadv(i,j)
  10  continue
c
c      close (413)
c      close (414)
c      close (415)
c      close (416)
c
#endif
#if defined surfpress & defined freesurf & (defined smallpsdt2 | defined smallpsdt4)
      if (npsrep.gt.1) then
c
#endif
c-----------------------------------------------------------------------
c Save time for large dt.
c-----------------------------------------------------------------------
c
      ttsecsave = ttsec
c
#if defined ext_tide
c-----------------------------------------------------------------------
c Reset tidal data for large dt.
c-----------------------------------------------------------------------
c
c      write (6,*) '--------CLEAN_SMLDTPS: setting tides-------------'
c      call flush (6)
      ttsec = ttsecsave - c2*dtts
      call tid_bar_rset
c
      ttsec = ttsecsave - dtts
      call tid_bar_rset
c
      ttsec = ttsecsave
      call tid_bar_rset
c
#endif
c-----------------------------------------------------------------------
c Swap data for large dt calculation.
c-----------------------------------------------------------------------
c
      do 20, j = 1, jmt
      do 20, i = 1, imt
c
c Save barotropic velocities for small dt.
c
         ubarbps(i,j) = ubarob(i,j)
         ubarps(i,j)  = ubaro(i,j)
         vbarbps(i,j) = vbarob(i,j)
         vbarps(i,j)  = vbaro(i,j)
c
c Save surface pressure and tendancies for small dt.
c
         pbps(i,j)   = pb(i,j)
         pps(i,j)    = p(i,j)
         ptdbps(i,j) = ptdbsv(i,j)
         ptdps(i,j)  = ptd(i,j)
c
c Save surface elevation and stretching for small dt.
c
         etatbps(i,j)   = etatb(i,j)
         etatps(i,j)    = etat(i,j)
         fractbps(i,j)  = fractb(i,j)
         etavps(i,j)    = etav(i,j)
c
#if !defined smallpsdt3
c Load barotropic velocities for large dt.
c
         ubarob(i,j) = ubaruv(i,j)
         ubaro(i,j)  = ubaronew(i,j)
         vbarob(i,j) = vbaruv(i,j)
         vbaro(i,j)  = vbaronew(i,j)
c
#else
c Load barotropic velocities prior to rolling for large dt.
c
         ubarob(i,j) = ubarbuv(i,j)
         ubaro(i,j)  = ubaruv(i,j)
         vbarob(i,j) = vbarbuv(i,j)
         vbaro(i,j)  = vbaruv(i,j)
c
#endif
c Load surface pressure and tendancies for large dt.
#if !defined smallpsdt3
c (doing necessary rollings in time).
c
         pb(i,j)   = puv(i,j)
         ptdb(i,j) = ptduv(i,j)
         ptd(i,j)  = p(i,j) - pbuv(i,j)
c
#else
c (postpone rollings in time).
c
         pb(i,j)   = pbuv(i,j)
         ptdb(i,j) = ptdbuv(i,j)
         ptd(i,j)  = p(i,j) - pb(i,j)
c
#endif
c Load surface elevation and stretching for large dt.
c
         etatb(i,j)   = etatbuv(i,j)
         etat(i,j)    = etatuv(i,j)
         fractb(i,j)  = fractbuv(i,j)
         etav(i,j)    = etavuv(i,j)
#if defined smallpsdt3
         hdvcf(i,j)=hdv(i,j)+etav(i,j)
# if defined sprsnrm01
         hdvcfx(i,j)=hdvcf(i,j)*uland(i,j)
         hdvcfy(i,j)=hdvcf(i,j)*vland(i,j)
# endif
         hdvcf(i,j)=hdvcf(i,j)*min(fkmq(i,j),c1)
#endif
  20  continue
#if defined surfpress & defined freesurf & (defined smallpsdt2 | defined smallpsdt4)
      endif
#endif
#if defined smallpsdt3
c
c Reset time change of surface pressure to reflect divergence of transport.
c
      call h_frc_rst (uf,vf,fac)
# if !defined sprsnrm01 | !defined sprsnrm02
      call div_fld (uf,vf,ztd,hdvcf,fac)
# else
      call div_fld (uf,vf,ztd,hdvcfx,hdvcfy,fac)
# endif
      call reset_ps (.true.)
c
# if defined rflct_ptd
      do 23, j = 2, jmtm1
         ptd(1,j) = ptd(2,j)
         ptd(imt,j) = ptd(imtm1,j)
  23  continue
c
      do 27, i = 1, imt
         ptd(i,1) = ptd(i,2)
         ptd(i,jmt) = ptd(i,jmtm1)
  27  continue
c
# endif
c Roll the correct long-time pressure to the back position.
c
      do 30, j = 1, jmt
      do 30, i = 1, imt
# if defined scaltsunflt | defined scaluvunflt
#  if !defined smldtscl
         punflt(i,j) = pb(i,j) + ptd(i,j)
#  else
#   if defined smldtscl2
         ptd(i,j) = punflt(i,j)
#   endif
         punflt(i,j) = pb(i,j) + punflt(i,j)
#  endif
# endif
         p(i,j) = pb(i,j) + ptd(i,j)
         pb(i,j) = puv(i,j)
  30  continue
c
#endif
#if defined surfpress & defined freesurf & defined smallpsdt4
c-----------------------------------------------------------------------
c Construct barotropic advection terms.
c-----------------------------------------------------------------------
c
c      count = count + 1
c      write (cntstr,'(i6.6)') count
c      open (413, file='ubaradv'//cntstr//'.dat', status='unknown')
c      open (414, file='vbaradv'//cntstr//'.dat', status='unknown')
c      open (415, file='detavadv'//cntstr//'.dat', status='unknown')
c      open (416, file='detatadv'//cntstr//'.dat', status='unknown')
c
c  current code only works for npsrep even
c
      iptadv  = 1 - iptadv
      iptbadv = 1 - iptbadv
      fx      = c1/FLoaT(npsrep)
c
      do 40, j = 1, jmt
      do 40, i = 1, imt
c         fx            = c1/fracv(i,j)  ! wrong time
         uwkadv(i,j,iptadv) = usmadv(i,j,icursm)
         vwkadv(i,j,iptadv) = vsmadv(i,j,icursm)
         ubaradv(i,j)  = fx*(uwkadv(i,j,iptadv)+uwkadv(i,j,iptbadv))
         vbaradv(i,j)  = fx*(vwkadv(i,j,iptadv)+vwkadv(i,j,iptbadv))
         usmadv(i,j,icursm) = c0
         vsmadv(i,j,icursm) = c0
         usmadv(i,j,ioldsm) = c0
         vsmadv(i,j,ioldsm) = c0
         ptdwk(i,j,iptadv) = ptdsm(i,j,icursm)
# if defined scaltsunflt | defined scaluvunflt
#  if !defined smldtscl
         punflt(i,j) = pb(i,j) + ptd(i,j)
#  else
#   if defined smldtscl2
         ptd(i,j) = punflt(i,j)
#   endif
         ptd(i,j) = ptdwk(i,j,iptadv) + ptdwk(i,j,iptbadv)
         punflt(i,j) = pbuv(i,j) + ptd(i,j)
         ptdsm(i,j,icursm) = c0
         ptdsm(i,j,ioldsm) = c0
#  endif
# endif
c          write (413,*) ubaradv(i,j)
c          write (414,*) vbaradv(i,j)
c          write (415,*) detavadv(i,j)
c          write (416,*) detatadv(i,j)
  40  continue
c
c      close (413)
c      close (414)
c      close (415)
c      close (416)
c
#endif
c
      return
      end

