#if !defined freesurf | !defined sprsnrm01 | !defined sprsnrm02
      subroutine div_fld(uvel,vvel,zt,hhv,fac)
#else
      subroutine div_fld(uvel,vvel,zt,hhvx,hhvy,fac)
#endif
c
c=======================================================================
c                                                                    ===
c  This subroutine calculates the zt=fac*Div(hhv [uvel,vvel])        ===
c                                                                    ===
c=======================================================================
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <fullwd.h>
#include <onedim.h>
#if defined surfpress & defined freesurf & (defined fdgtideztd | defined tidepredctr )
# include <scalar.h>
# include <tidesp.h>
#endif
#if defined coast & defined divmskavg
# include <fieldsbar.h>
#endif
#if defined surfpress & defined freesurf & defined tidepredctr
# include <fields.h>
# include <sinfo.h>
#endif
c
c-----------------------------------------------------------------------
c  Define local variables and arrays.
c-----------------------------------------------------------------------
c
      FLOAT
     *      fluxhorie1,fluxhorie2,fluxhorie,
     *      fluxhoriw1,fluxhoriw2,fluxhoriw,
     *      fluxvertn1,fluxvertn2,fluxvertn,
     *      fluxverts1,fluxverts2,fluxverts,
     *      fluxhori,fluxvert
#if defined surfpress & defined freesurf & defined tidepredctr
     &      ,fac2
#endif
      FLOAT
     *      zt(imt,jmt),uvel(imt,jmt),vvel(imt,jmt),fac
#if !defined freesurf | !defined sprsnrm01 | !defined sprsnrm02
     &      ,hhv(imt,jmt)
#else
     &      ,hhvx(imt,jmt),hhvy(imt,jmt)
#endif
      integer i,j,iend,istr
#ifdef coast
      integer l
#endif
#if defined coast & defined divmskavg
      FLOAT
     &      wk1,wk2
      integer ii,jj,nodivav
      integer pavgmsk(imt,jmt)
      logical first
#endif
#ifdef divdump
      integer dmpcnt,dmptim
      save dmpcnt,dmptim
      data dmpcnt,dmptim/0,1/
#endif
#if defined coast & defined divmskavg
      save first,pavgmsk
      data first,pavgmsk/.true.,nwds*0/
#endif
c
c-----------------------------------------------------------------------
c  Begin executable code.
c-----------------------------------------------------------------------
#if defined coast & defined divmskavg
c
c-----------------------------------------------------------------------
c  On first pass, set up averaging mask.
c-----------------------------------------------------------------------
c
      if (first) then
         do j = 2, jmtm1
            do i = 2, imtm1
               wk1 = fkmq(i,j)*fkmq(i-1,j)*fkmq(i,j-1)*fkmq(i-1,j-1)
               wk2 = fkmq(i,j)+fkmq(i-1,j)+fkmq(i,j-1)+fkmq(i-1,j-1)
               if (wk1.gt.c0) then
                  pavgmsk(i,j) = 2
               elseif (wk2.gt.c0) then
                 pavgmsk(i,j) = 1
               endif
            enddo
         enddo
         first = .false.
      endif
c
c-----------------------------------------------------------------------
c  Compute divergences.
c-----------------------------------------------------------------------
#endif
c
#if defined surfpress & defined freesurf & defined tidepredctr2
      fac2 = c2/(alphav*thetasd*grav*c2dtps*c2dtps)
c
#endif
      do 10 j=1,jmt
         do 10 i=1,imt
            zt(i,j)=c0
 10      continue
c
#ifdef divdump
      dmpcnt = dmpcnt + 1
      if (dmpcnt.eq.dmptim) then
         open (413, file='ufrc.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) uvel(i,j)
            enddo
         enddo
         close(413)
         open (413, file='vfrc.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) vvel(i,j)
            enddo
         enddo
         close(413)
# if !defined sprsnrm01 | !defined sprsnrm02
         open (413, file='hhv.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) hhv(i,j)
            enddo
         enddo
         close(413)
# else
         open (413, file='hhvx.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) hhvx(i,j)
            enddo
         enddo
         close(413)
         open (413, file='hhvy.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) hhvy(i,j)
            enddo
         enddo
         close(413)
# endif
         open (413, file='dxt.dat', status='unknown')
         do i = 1, imt
            write (413,*) dxt2r(i)
         enddo
         open (413, file='dyt.dat', status='unknown')
         do j = 1, jmt
            write (413,*) dyt2r(j)
         enddo
         open (413, file='cs.dat', status='unknown')
         do j = 1, jmt
            write (413,*) cs(j)
         enddo
         open (413, file='fac.dat', status='unknown')
         write (413,*) fac
         close(413)
# if defined coast
         open (413, file='isp.dat', status='unknown')
         open (415, file='iep.dat', status='unknown')
         write (413,*) jmt,lseg
         write (415,*) jmt,lseg
         do j = 1, jmt
            write (413,*) (isp(j,l), l=1,lseg)
            write (415,*) (iep(j,l), l=1,lseg)
         enddo
         close(413)
         close(415)
# endif
# if defined coast & defined divmskavg
         open (413, file='pavgmsk.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) pavgmsk(i,j)
            enddo
         enddo
         close(413)
# endif
      endif
#endif
      do 40 j=2,jmt-1
c
#ifdef coast
c
c  Choose to compute at sea points only and avoid land points
c
         do 30 l=1,lseg
            istr=isp(j,l)
            if(istr.eq.0) go to 40
            iend=iep(j,l)
#else
c
            istr=2
            iend=imt-1
#endif
            do 20 i=istr,iend
c
#if !defined freesurf | !defined sprsnrm01 | !defined sprsnrm02
               fluxhorie1=hhv(i,j)*uvel(i,j)
               fluxhorie2=hhv(i,j-1)*uvel(i,j-1)
#else
               fluxhorie1=hhvx(i,j)*uvel(i,j)
               fluxhorie2=hhvx(i,j-1)*uvel(i,j-1)
#endif
               fluxhorie=(fluxhorie1+fluxhorie2)
#if defined freesurf & defined sprsnrm01 & defined sprsnrm02 & defined coast
     &                   *FLoaT(landt(i+1,j))
#endif
c
#if !defined freesurf | !defined sprsnrm01 | !defined sprsnrm02
               fluxhoriw1=hhv(i-1,j)*uvel(i-1,j)
               fluxhoriw2=hhv(i-1,j-1)*uvel(i-1,j-1)
#else
               fluxhoriw1=hhvx(i-1,j)*uvel(i-1,j)
               fluxhoriw2=hhvx(i-1,j-1)*uvel(i-1,j-1)
#endif
               fluxhoriw=(fluxhoriw1+fluxhoriw2)
#if defined freesurf & defined sprsnrm01 & defined sprsnrm02 & defined coast
     &                   *FLoaT(landt(i-1,j))
#endif
c
               fluxhori=(fluxhorie-fluxhoriw)*dxt2r(i)
c
c
#if !defined freesurf | !defined sprsnrm01 | !defined sprsnrm02
               fluxvertn1=hhv(i,j)*vvel(i,j)
               fluxvertn2=hhv(i-1,j)*vvel(i-1,j)
#else
               fluxvertn1=hhvy(i,j)*vvel(i,j)
               fluxvertn2=hhvy(i-1,j)*vvel(i-1,j)
#endif
               fluxvertn=cs(j)*(fluxvertn1+fluxvertn2)
#if defined freesurf & defined sprsnrm01 & defined sprsnrm02 & defined coast
     &                   *FLoaT(landt(i,j+1))
#endif
c
#if !defined freesurf | !defined sprsnrm01 | !defined sprsnrm02
               fluxverts1=hhv(i,j-1)*vvel(i,j-1)
               fluxverts2=hhv(i-1,j-1)*vvel(i-1,j-1)
#else
               fluxverts1=hhvy(i,j-1)*vvel(i,j-1)
               fluxverts2=hhvy(i-1,j-1)*vvel(i-1,j-1)
#endif
               fluxverts=cs(j-1)*(fluxverts1+fluxverts2)
#if defined freesurf & defined sprsnrm01 & defined sprsnrm02 & defined coast
     &                   *FLoaT(landt(i,j-1))
#endif
c
               fluxvert=(fluxvertn-fluxverts)*dyt2r(j)
c
c
#if !defined surfpress | !defined freesurf | !defined fdgtideztd
               zt(i,j)=(fluxhori+fluxvert)*fac
#else
               zt(i,j)=-dtsrftd(i,j)*fac*c2/c2dtps
#endif
#if defined surfpress & defined freesurf & defined tidepredctr2
     &                 + (srftd(i,j,itda)*grav - pb(i,j))*fac2
#endif
c
 20         continue
#ifdef coast
 30      continue
#endif
#ifdef cyclic
         zt(1,j)=zt(imum1,j)
         zt(imu,j)=zt(2,j)
#endif
 40   continue
c
#if defined coast & defined divmskavg
c-----------------------------------------------------------------------
c  Replace divergences next to land with averages of neighboring points
c  that do not touch land (and are not corrupted by zeros).
c-----------------------------------------------------------------------
c
      do 44 j = 2, jmtm1
         do 43 i = 2, imtm1
            if (pavgmsk(i,j).eq.1) then
               nodivav = 0
               wk1  = c0
               do 42 jj = j-1, j+1
                  do 41 ii = i-1, i+1
                     if (pavgmsk(ii,jj).eq.2) then
                        wk1  = wk1 + zt(ii,jj)
                        nodivav = nodivav + 1
                     endif
 41               continue
 42            continue
               if (nodivav.gt.0) zt(i,j) = wk1/FLoaT(nodivav)
            endif
 43      continue
 44   continue
c
#endif
#ifdef filtdiv
c-----------------------------------------------------------------------
c  Try shapiro filtering divergence. (Past experience indicates this
c  corrupts barotropic continuity).
c-----------------------------------------------------------------------
c
       call shap_lev(zt,imtm1,jmtm1,zgrid,16)
c
#endif
#ifdef cyclic
c-----------------------------------------------------------------------
c  Extra insurance of periodicity.
c-----------------------------------------------------------------------
c
      do 50, j = 1, jmt
         zt(1,j) = zt(imum1,j)
         zt(imu,j) = zt(2,j)
  50  continue
c
#endif
#ifdef divdump
      if (dmpcnt.eq.dmptim) then
         open (413, file='ztd.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) zt(i,j)
            enddo
         enddo
         close(413)
# ifdef sunflush
         call flush (413)
# endif
      endif
#endif
      return
      end
