      subroutine expdpthas
c
c=======================================================================
c                                                                    ===
c  This routine sets the depths at the tracers (T,S)  and velocity   ===
c  (u,v) points. These depths are used to interpolate these fields   ===
c  to hybrid (topography-following) coordinates.                     ===
c                                                                    ===
c  This version is used as a quick-fix for the free-surface          ===
c  boot-strap initialization for PB.  The true fix would be to modify===
c  start_ps.F to solve deta/dt + div([H+eta-deta]Ubaro) = 0 for deta.===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <fields.h>
#include <vertical.h>
#include <scalar.h>
#include <vertslabs.h>
#include <fieldsbar.h>
#include <workspb.h>
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i,j
#ifndef barotropic
     *        ,k
#endif
      FLOAT
     *     fac1
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
c  Set free surface at the T points.
c
      fac1=c1/grav
      do 100 j=1,jmt
      do 100 i=1,imt
         detat(i,j)=ptd(i,j)*fac1
 100  continue
c
c  Set free surface at the U-V points.
c
      do 130 j=1,jmtm1
        do 120 i=1,imtm1
          detav(i,j)=p25*
     *      (detat(i,j)+detat(i+1,j)+detat(i,j+1)+detat(i+1,j+1))
 120    continue
#ifdef cyclic
        detav(1,j)=detav(imtm1,j)
        detav(imt,j)=detav(2,j)
#else
        detav(imt,j)=detav(imtm1,j)
#endif
 130  continue
      do 140 i=1,imt
        detav(i,jmt)=detav(i,jmtm1)
 140  continue
c
      return
      end
