c
c=======================================================================
c  Include file "fields.h"
c=======================================================================
#ifndef rmdocinc
c
c  HR    reciprocal depth over tracer points.
c  HV    reciprocal depth over velocity points.
c  P     transport stream function, present timestep.
c  PB    transport stream function, previous timestep.
c  ZTD   time change of vorticity.
c  ZTDB  time change of vorticity unscaled for output purposes.
c  ZUN   time change of vertically averaged zonal forcing for the row
c        to the north.
c  ZUS   time change of vertically averaged zonal forcing for the row
c        to the south.
c  ZVN   time change of vertically averaged meridional forcing for the
c        row to the north.
c  ZVS   time change of vertically averaged meridional forcing for the
c        row to the south.
c
c=======================================================================
#endif
c
      FLOAT 
     &      hr(imt,jmt),hv(imt,jmt),p(imt,jmt),pb(imt,jmt),ztd(imt,jmt),
     &      ztdb(imt,jmt),zun(imt),zus(imt),zvn(imt),zvs(imt)
#if defined nest2smaller | defined scaltsunflt | defined scaluvunflt
     &                ,punflt(imt,jmt)
#endif
#if defined scaltsunflt | defined scaluvunflt & defined smldtscl
     &                ,pbunflt(imt,jmt)
#endif
      common /fields/ p,pb,ztd,ztdb,zun,zvn,zus,zvs,hr,hv
#if defined nest2smaller | defined scaltsunflt | defined scaluvunflt
     &                ,punflt
#endif
#if defined scaltsunflt | defined scaluvunflt & defined smldtscl
     &                ,pbunflt
#endif

