c
c=======================================================================
c  Include file "filtdat.h"
c=======================================================================
#ifndef rmdocinc
c
c  ICNTP    trans/Ps: counter for Shapiro filter applications.
c  ICNTPB   trans/Ps bndy: counter for Shapiro filter applications.
c  ICNTT    tracers: counter for Shapiro filter applications.
c  ICNTV    velocity: counter for Shapiro filter applications.
c  ICNTZ    vorticity: counter for Shapiro filter applications.
c  MIXTRC   tracers horizontal mixing scheme:
c           [1] Shapiro filter,
c           [2] Laplacian at constant depths,
c           [3] Laplacian along terrain following levels.
c  MIXVEL   momentum equation horizontal mixing scheme:
c           [1] Shapiro filter,
c           [2] Laplacian at constant depths,
c           [3] Laplacian along terrain following levels.
c  MIXZTD   mixing scheme for the rate of change vorticity (ZTD) or UHAT:
c           [1] Shapiro filter,
c           [2] Laplacian.  (vorticity only)
c  NFRQP    trans/Ps: number of timesteps between filter applications.
c  NFRQPB   trans/Ps bndy: number of timesteps between filter applications.
c  NFRQT    tracers: number of timesteps between filter applications.
c  NFRQV    velocity: number of timesteps between filter applications.
c  NFRQZ    vorticity: number of timesteps between filter applications.
c  NORDP    trans/Ps: order of the Shapiro filter.
c  NORDPB   trans/Ps bndy: order of the Shapiro filter.
c  NORDT    tracers: order of the Shapiro filter.
c  NORDV    velocity: order of the Shapiro filter.
c  NORDZ    vorticity: order of the Shapiro filter.
c  NTIMP    trans/Ps: number of times to apply the Shapiro filter.
c  NTIMPB   trans/Ps bndy: number of times to apply the Shapiro filter.
c  NTIMT    tracers: number of times to apply the Shapiro filter.
c  NTIMV    velocity: number of times to apply the Shapiro filter.
c  NTIMZ    vorticity: number of times to apply the Shapiro filter.
c
c=======================================================================
#endif
c
#if !defined shapbiodiff & !defined filtduvhat3 & !defined pfiltint
      integer icntp,icntt,icntv,icntz,mixtrc,mixvel,mixztd,nfrqp,nfrqt,
     &        nfrqv,nfrqz,nordp,nordt,nordv,nordz,ntimp,ntimt,ntimv,
     &        ntimz,nordpb,ntimpb,nfrqpb,icntpb
#elif defined filtduvhat3 | defined pfiltint
      integer icntp,icntt,icntv,icntz,mixtrc,mixvel,mixztd,nfrqp,nfrqt,
     &        nfrqv,nfrqz,nordp,nordt,nordv,nordz,ntimp,ntimt,ntimv,
     &        ntimz,nordpb,ntimpb,nfrqpb,icntpb,nfrqz2,nordz2,ntimz2,
     &        icntz2
#else
      integer icntp,icntv,icntz,mixtrc,mixvel,mixztd,nfrqp,nfrqv,nfrqz,
     &        nordp,nordv,nordz,ntimp,ntimv,ntimz,nordpb,ntimpb,nfrqpb,
     &        icntpb
      integer icntt(nt),nfrqt(nt),nordt(nt),ntimt(nt)
#endif
c
      common /ifiltdat/ mixvel,mixtrc,mixztd,nordv,ntimv,nfrqv,icntv,
     &                  nordt,ntimt,nfrqt,icntt,nordz,ntimz,nfrqz,icntz,
     &               nordp,ntimp,nfrqp,icntp,nordpb,ntimpb,nfrqpb,icntpb
#if defined filtduvhat3 | defined pfiltint
     &               ,nordz2,ntimz2,nfrqz2,icntz2
#endif

