      subroutine headln (unit)
c
c=======================================================================
c                                                                    ===
c  This routine writes a date stamp header to an echo file.          ===
c                                                                    ===
c  On Input:                                                         ===
c                                                                    ===
c     UNIT   Unit number of the echo file.  (integer)                ===
c                                                                    ===
c  Common Blocks:                                                    ===
c                                                                    ===
c  /VERSION/                                                         ===
c                                                                    ===
c     MODEL   The name of the model or code.  (character)            ===
c     VNUM    Version number.  (character)                           ===
c                                                                    ===
c  Calls:  GET_DATE,  LENGTH                                         ===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data.
c-----------------------------------------------------------------------
c
#include <version.h>
#if (defined nest2smaller | defined nest2larger) & defined use_mpi
# include <cdefs.h>
# include <param.h>
# include <pconst.h>
# include <mpif.h>
# include <nest.h>
#endif
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer lenstr,lnstr2,sbgn,sbn2,send,snd2,unit
      character*8  fmt
      character*44 date_str
#if (defined nest2smaller | defined nest2larger) & defined use_mpi
      integer       status
      character*128 hostname
#endif
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
c-----------------------------------------------------------------------
c  Write date stamp in echo file, if one can be created.
c-----------------------------------------------------------------------
c
      call get_date(date_str)
      call length (date_str,lenstr,sbgn,send)
      if(lenstr.gt.0) then
        write (fmt,10) (80-lenstr)/2
        write (unit,fmt) date_str(sbgn:send)
      endif
c
c-----------------------------------------------------------------------
c  Write model name and version number.
c-----------------------------------------------------------------------
c
      call length (model,lenstr,sbgn,send)
      call length (vnum,lnstr2,sbn2,snd2)
      write (unit,20) model(sbgn:send),vnum(sbn2:snd2)
c
#if (defined nest2smaller | defined nest2larger) & defined use_mpi
c-----------------------------------------------------------------------
c  For MPI nested processes, record process id and host name.
c-----------------------------------------------------------------------
c
      call mpi_get_processor_name (hostname, lenstr, status)
      call length (hostname,lenstr,sbgn,send)
c
      write (unit,30) currtid,hostname(sbgn:send)
c
#endif
      return
c
  10  format ('(/',i2,'x,a)')
  20  format (/a,',  Version ',a)
#if (defined nest2smaller | defined nest2larger) & defined use_mpi
  30  format (/'MPI process ',i5.5,' on ',a)
#endif
c
      end
