      subroutine ini_ps_dts
c
c-----------------------------------------------------------------------
c  Define global data.
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <dtswap.h>
#include <fields.h>
#include <fieldsbar.h>
#include <fullwd.h>
#include <scalar.h>
#include <vertical.h>
#include <workspb.h>
C    &                                                                 ^
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i,j
      FLOAT
     &      dtsave
#if defined surfpress & defined freesurf & defined smallpsdt2
     &        ,fx
#endif
c
c-----------------------------------------------------------------------
c  Begin executable code.
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c Initialize surface pressure for small timestep.
c-----------------------------------------------------------------------
c
      if (npsrep.gt.1) then
         dtsave = dtts
         dtts   = dtsf
      endif
c
#if surfpress & defined freesurf & (defined rset_dps | defined smallpsdt3 | defined specpsic)
      call start_ps (p,pb,ztd)
#else
      call start_ps (p,pb)
#endif
#if defined oias | defined nest2smaller | defined nest2larger
      call expdpthic
#else
      call expand_depth
#endif
c
c-----------------------------------------------------------------------
c Save data for small dt.
c-----------------------------------------------------------------------
c
      do 10, j = 1, jmt
      do 10, i = 1, imt
c
c Save barotropic velocities for small dt.
c
         ubarbps(i,j) = ubarob(i,j)
         ubarps(i,j)  = ubaro(i,j)
         vbarbps(i,j) = vbarob(i,j)
         vbarps(i,j)  = vbaro(i,j)
c
c Save surface pressure and tendancies for small dt.
c
         pbps(i,j)   = pb(i,j)
         pps(i,j)    = p(i,j)
         ptdbps(i,j) = ptd(i,j)
         ptdps(i,j)  = ptd(i,j)
c
c Save surface elevation and stretching quantities for small dt.
c
         etatbps(i,j)   = etatb(i,j)
         etatps(i,j)    = etat(i,j)
         fractbps(i,j)  = fractb(i,j)
         etavps(i,j)    = etav(i,j)
c
#if defined surfpress & defined freesurf & defined smallpsdt2
c Construct barotropic advection terms.
c
          fx            = p5*fracvb(i,j)/fracv(i,j)
          ubaradv(i,j)  = fx*(ubaro(i,j)+ubarob(i,j))
          vbaradv(i,j)  = fx*(vbaro(i,j)+vbarob(i,j))
          detavadv(i,j) = detav(i,j)
          detatadv(i,j) = detat(i,j)
c
#endif
  10  continue
c
      if (npsrep.gt.1) then
c
c-----------------------------------------------------------------------
c Initialize surface pressure for large timestep.
c-----------------------------------------------------------------------
c
      dtts   = dtsave
      dtsave = dtsf
      dtsf   = dtts
c
#if surfpress & defined freesurf & (defined rset_dps | defined smallpsdt3 | defined specpsic)
      call start_ps (p,pb,ztd)
#else
      call start_ps (p,pb)
#endif
#if defined oias | defined nest2smaller | defined nest2larger
      call expdpthic
#else
      call expand_depth
#endif
      dtsf   = dtsave
c
c-----------------------------------------------------------------------
c Save data for large dt.
c-----------------------------------------------------------------------
c
      do 20, j = 1, jmt
      do 20, i = 1, imt
c
c Save barotropic velocities for large dt.
c
         ubarbuv(i,j) = ubarob(i,j)
         ubaruv(i,j)  = ubaro(i,j)
         vbarbuv(i,j) = vbarob(i,j)
         vbaruv(i,j)  = vbaro(i,j)
c
c Save surface pressure and tendancies for large dt.
c
         pbuv(i,j)   = pb(i,j)
         puv(i,j)    = p(i,j)
         ptdbuv(i,j) = ptd(i,j)
         ptduv(i,j)  = ptd(i,j)
c
c Save surface elevation and stretching quantities for large dt.
c
         etatbuv(i,j)   = etatb(i,j)
         etatuv(i,j)    = etat(i,j)
         fractbuv(i,j)  = fractb(i,j)
         etavuv(i,j)    = etav(i,j)
c
#if defined surfpress & defined freesurf & defined smallpsdt4
c Construct barotropic advection terms.
c
          fx            = p5*fracvb(i,j)/fracv(i,j)
          ubaradv(i,j)  = fx*(ubaro(i,j)+ubarob(i,j))
          vbaradv(i,j)  = fx*(vbaro(i,j)+vbarob(i,j))
          uwkadv(i,j,iptadv) = p5*ubaradv(i,j)
          vwkadv(i,j,iptadv) = p5*vbaradv(i,j)
          uwkadv(i,j,iptbadv) = p5*ubaradv(i,j)
          vwkadv(i,j,iptbadv) = p5*vbaradv(i,j)
c
#endif
  20  continue
c
      endif
c
      return
      end

