c
c=======================================================================
c  Include file "iounits.h"
c=======================================================================
#ifndef rmdocinc
c
c  ABSINP    logical unit for ABSONAM
c  ABSONAM   absorption coefficients input ASCII file name.
c  APARNAM   assimilation parameters input ASCII file name.
c  ASSNAME   assimilation NetCDF input file name.
c  BPARNAM   biological model parameters input ASCII file name.
c  DPOSNAM   drifters initial positions input ASCII file name.
c  FRCNAME   forcing fields NetCDF input file name.
c  GRDNAME   GRIDS NetCDF input file name.
c  IFPRNT    switch to print verbose grid information to STDOUT.
c  INPNAME   initial/boundary conditions NetCDF input file name.
c  INPPRF    Unit number for sampling input file.
c  IOIOUT    IOI verbose echo output logical unit.
c  IOIPAR    IOI parameters input logical unit.
c  NRGNAME   energy and diagnostics output NetCDF file name.
c  NSTINM    Name of parameter input file for this nested run.
c  NSTONM    Name of output log file for this nested run.
c  OUTNAME   PE model fields output NetCDF file name.
c  OUTPRF    Unit number for sampling output file.
c  PBISNAM   Name of netCDF pressure bias file.
c  SAMPIN    Name of sampling input file.
c  SAMPOUT   Name of sampling output file.
c  SMLHNM    Name of host on which to launch smaller grid.
c  SMLINM    Name of parameter input file for smaller grid.
c  SMLONM    Name of output log file for smaller grid.
c  SMLTNM    Name of executable for smaller grid.
c  STDINP    standard input logical unit.
c  STDOUT    standard output logical unit.
c  TDBXIN    Unit number for tidal regions file.
c  TDPHDAT   Name for ASCII input file containing tide phase data.
c  TDPHIN    Unit number for file containing tide phase data.
c  TIDEBOX   Name for ASCII input file defining tidal regions.
c  TIDEDAT   Name for netCDF input file containing tidal fields.
c  TRKINP    Lagrangian tracjectories parameters input logical unit.
c  TRKNAME   Lagrangian tracjectories output NetCDF file name.
c  TSRCINP   tracers point source input logical unit.
c  TSRCNAM   tracers point source file name.
c  USRINP    User file input logical unit.
c  USRNAME   User generic input file name.
c  XPARNAM   sub-domain extraction parameters input ASCII file name.
c  XTRINP    sub-domain extraction parameters input logical unit.
c
c=======================================================================
#endif
c
      common /iiounits/ absinp,bioinp,ifprnt,inpprf,ioiout,ioipar
     &                  ,outprf,stdinp,stdout,tdbxin,tdphin,trkinp,
     &                  tsrcinp,usrinp,xtrinp
#if defined surfpress | defined pcg5
     *                  ,tst1out,tst2out,tst3out,tst4out,tst5out,tst6out
     *                  ,tst7out,tst8out,tst9out,tst10out,tst11out
#endif
      integer absinp,bioinp,ifprnt,inpprf,ioiout,ioipar,outprf,
     &        stdinp,stdout,tdbxin,tdphin,trkinp,tsrcinp,usrinp,xtrinp
#if defined surfpress | defined pcg5
     *                  ,tst1out,tst2out,tst3out,tst4out,tst5out,tst6out
     *                  ,tst7out,tst8out,tst9out,tst10out,tst11out
#endif
c
      common /ciounits/ absonam,aparnam,assname,bparnam,dposnam,frcname,
     &                  grdname,inpname,nrgname,nstinm,nstonm,outname,
     &                  pbisnam,sampin,sampout,smlhnm,smlinm,smlonm,
     &                  smltnm,tdphdat,tidebox,tidedat,trkname,tsrcnam,
     &                  usrname,xparnam
      character*80 absonam,aparnam,assname,bparnam,dposnam,frcname,
     &             grdname,inpname,nrgname,nstinm,nstonm,outname,
     &             pbisnam,sampin,sampout,tdphdat,tidebox,tidedat,
     &             trkname,tsrcnam,usrname,xparnam
#ifndef nest2smaller
     &             ,smlhnm,smlinm,smlonm,smltnm
#else
     &             ,smlhnm(mxsubd),smlinm(mxsubd),smlonm(mxsubd),
     &              smltnm(mxsubd)
#endif
