      subroutine nest_lim_bc
c
c=======================================================================
c                                                                    ===
c This routine limits the BCs received from a larger domain.         ===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#ifdef use_mpi
# include <mpif.h>
#else
# include <fpvm3.h>
#endif
#include <bndata.h>
#include <iounits.h>
#include <nest.h>
#include <options.h>
#include <rhomean.h>
#include <workspa.h>
#include <voldat.h>
#include <fullwd.h>
#ifndef surfpress
# include <fields.h>
# include <scalar.h>
#else
# include <sinfo.h>
#endif
#include <vertical.h>
c
c-----------------------------------------------------------------------
c  Define local and equivalence data.
c-----------------------------------------------------------------------
c
      integer ic,ii,j,jc,jf,k,n,nbn,nbnp,nin
      FLOAT
     &      dne,dnw,dse,dsum,dsw
      FLOAT
     &      df(3)
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
c-----------------------------------------------------------------------
c  Limit tracer fields.
c-----------------------------------------------------------------------
c
      do 140, n = 1, iopt(8)
      do 140, k = 1, km
c
c  Western boundary
c
         nbn  = 1
         nbnp = 2
         do 30, jc = 1, nylc
            jf = jc*horiz_fac
            dsum = c0
            nin  = 0
            do 10, j = jf-1, jf+1
               ip = nbnp + (jf-1)*imt
#ifdef coast
               if (landt(nbnp,j).eq.1) then
#endif
                  df(j-jf+2) = xt(ip,k,n) - tbc0(j,k,n,2,itbp,west)
                  dsum = dsum + df(j-jf+2)
                  nin  = nin + 1
#ifdef coast
               endif
#endif
  10        continue
            if (nin .gt. 0) then
               dsum = dsum/FLoaT(nin)
               do 20, j = jf-1, jf+1
#ifdef coast
                  if (landt(nbn,j).eq.1) then
#endif
                     tbc0(j,k,n,1,itbp,west) = tbc0(j,k,n,1,itbp,west)
     &                                         + (df(j-jf+2)-dsum)
                     if (j.eq.2)     dsw = (df(j-jf+2)-dsum)
                     if (j.eq.jmtm2) dnw = (df(j-jf+2)-dsum)
#ifdef coast
                  endif
#endif
  20           continue
            end if
  30     continue
c
c  Eastern boundary
c
         nbn  = imt
         nbnp = imtm1
         do 60, jc = 1, nylc
            jf = jc*horiz_fac
            dsum = c0
            nin  = 0
            do 40, j = jf-1, jf+1
               ip = nbnp + (jf-1)*imt
#ifdef coast
               if (landt(nbnp,j).eq.1) then
#endif
                  df(j-jf+2) = xt(ip,k,n) - tbc0(j,k,n,2,itbp,east)
                  dsum = dsum + df(j-jf+2)
                  nin  = nin + 1
#ifdef coast
               endif
#endif
  40        continue
            if (nin .gt. 0) then
               dsum = dsum/FLoaT(nin)
               do 50, j = jf-1, jf+1
#ifdef coast
                  if (landt(nbn,j).eq.1) then
#endif
                     tbc0(j,k,n,1,itbp,east) = tbc0(j,k,n,1,itbp,east)
     &                                         + (df(j-jf+2)-dsum)
                     if (j.eq.2)     dse = (df(j-jf+2)-dsum)
                     if (j.eq.jmtm2) dne = (df(j-jf+2)-dsum)
#ifdef coast
                  endif
#endif
  50           continue
            end if
  60     continue
c
c  Southern boundary
c
         nbn  = 1
         nbnp = 2
         do 90, ic = 1, nxlc
            ii = ic*horiz_fac
            dsum = c0
            nin  = 0
            do 70, i = ii-1, ii+1
               ip = i + (nbnp-1)*imt
#ifdef coast
               if (landt(i,nbnp).eq.1) then
#endif
                  df(i-ii+2) = xt(ip,k,n) - tbc0(i,k,n,2,itbp,south)
                  dsum = dsum + df(i-ii+2)
                  nin  = nin + 1
#ifdef coast
               endif
#endif
  70        continue
            if (nin .gt. 0) then
               dsum = dsum/FLoaT(nin)
               do 80, i = ii-1, ii+1
#ifdef coast
                  if (landt(i,nbn).eq.1) then
#endif
                     tbc0(i,k,n,1,itbp,south) = tbc0(i,k,n,1,itbp,south)
     &                                          + (df(i-ii+2)-dsum)
                     if (i.eq.2)     dsw = p5*(dsw + (df(i-ii+2)-dsum))
                     if (i.eq.imtm1) dse = p5*(dse + (df(i-ii+2)-dsum))
#ifdef coast
                  endif
#endif
  80           continue
            end if
  90     continue
c
c  Northern boundary
c
         nbn  = jmtm1
         nbnp = jmtm2
         do 130, ic = 1, nxlc
            ii = ic*horiz_fac
            dsum = c0
            nin  = 0
            do 100, i = ii-1, ii+1
               ip = i + (nbnp-1)*imt
#ifdef coast
               if (landt(i,nbnp).eq.1) then
#endif
                  df(i-ii+2) = xt(ip,k,n) - tbc0(i,k,n,2,itbp,north)
                  dsum = dsum + df(i-ii+2)
                  nin  = nin + 1
#ifdef coast
               endif
#endif
 100        continue
            if (nin .gt. 0) then
               dsum = dsum/FLoaT(nin)
               do 120, i = ii-1, ii+1
#ifdef coast
                  if (landt(i,nbn).eq.1) then
#endif
                     tbc0(i,k,n,1,itbp,north) = tbc0(i,k,n,1,itbp,north)
     &                                          + (df(i-ii+2)-dsum)
                     if (i.eq.2)     dnw = p5*(dnw + (df(i-ii+2)-dsum))
                     if (i.eq.imtm1) dne = p5*(dne + (df(i-ii+2)-dsum))
#ifdef coast
                  endif
#endif
 120           continue
            end if
 130     continue
c
c  Corners
c
#ifdef coast
         if (landt(1,1).eq.1) then
#endif
         tbc0(1,k,n,1,itbp,west)  = tbc0(1,k,n,1,itbp,west) + dsw
         tbc0(1,k,n,1,itbp,south) = tbc0(1,k,n,1,itbp,south) + dsw
#ifdef coast
         endif
#endif
c
#ifdef coast
         if (landt(1,jmtm1).eq.1) then
#endif
         tbc0(jmtm1,k,n,1,itbp,west) = tbc0(jmtm1,k,n,1,itbp,west) + dnw
         tbc0(1,k,n,1,itbp,north)    = tbc0(1,k,n,1,itbp,north) + dnw
#ifdef coast
         endif
#endif
c
#ifdef coast
         if (landt(imt,1).eq.1) then
#endif
         tbc0(1,k,n,1,itbp,east)    = tbc0(1,k,n,1,itbp,east) + dse
         tbc0(imt,k,n,1,itbp,south) = tbc0(imt,k,n,1,itbp,south) + dse
#ifdef coast
         endif
#endif
c
#ifdef coast
         if (landt(imt,jmtm1).eq.1) then
#endif
         tbc0(jmtm1,k,n,1,itbp,east) = tbc0(jmtm1,k,n,1,itbp,east) + dne
         tbc0(imt,k,n,1,itbp,north)  = tbc0(imt,k,n,1,itbp,north) + dne
#ifdef coast
         endif
#endif
c
 140  continue
c
      return
      end
