#if !defined usrdiagnostic | !defined nesttime
      subroutine nest_t_align (n_tim)
#else
      subroutine nest_t_align (n_tim,tsn1)
#endif
c
c=======================================================================
c                                                                    ===
c This routine checks the timing alignment during nesting.           ===
c                                                                    ===
c ------                                                             ===
c Input:                                                             ===
c ------                                                             ===
c                                                                    ===
c    N_TIM     Current time step.                    (integer)       ===
c                                                                    ===
c Common Blocks:                                                     ===
c                                                                    ===
c /IOUNITS/                                                          ===
c                                                                    ===
c    STDOUT    Unit number for standard output.      (integer)       ===
c                                                                    ===
c /NEST/                                                             ===
c                                                                    ===
c    NOSUBD    number of nested sub-domains.           (integer)     ===
c                                                                    ===
#if defined usrdiagnostic & defined nesttime
c -------                                                            ===
c Output:                                                            ===
c -------                                                            ===
c                                                                    ===
c    TSN1      Time spent in routine.                (real vector)   ===
c                                                                    ===
#endif
c Calls:  EXITUS, NEST_TEST                                          ===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#ifdef use_mpi
# include <mpif.h>
#else
# include <fpvm3.h>
#endif
#include <iounits.h>
#include <nest.h>
c
c-----------------------------------------------------------------------
c  Define local and equivalence data.
c-----------------------------------------------------------------------
c
      integer n,n_tim
#if defined usrdiagnostic & defined nesttime
      FLOAT
     &      tsn1(2)
# ifdef iforttime
     &      ,dum
      FLOAT
     &      dtime
# endif
#endif
#ifndef nestnultest
      integer lgind
      integer rec_tim(mdomp1),x_tim(mdomp1)
      logical ok
c
# if defined nest2larger & defined nest2smaller
      parameter (lgind=mdomp1)
# else
      parameter (lgind=1)
# endif
#endif
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
c-----------------------------------------------------------------------
c  Check time step for consistency.
c-----------------------------------------------------------------------
#ifndef nestnultest
c
      if (n_tim.gt.nest_start) then
c
# ifdef nest2smaller
         do 10, n = 1, nosubd
            x_tim(n)     = (n_tim-1)*itt_fac + 1
  10     continue
# endif
# ifdef nest2larger
         x_tim(lgind) = (n_tim-1)/itt_fac + 1
# endif
c
         call nest_test (n_tim,x_tim,ok,rec_tim)
c
         if (.not. ok) then
            write (stdout,900) n_tim
# ifdef nest2smaller
            do 20, n = 1, nosubd
               write (stdout,910) 'smaller',rec_tim(n),x_tim(n)
  20        continue
# endif
# ifdef nest2larger
            write (stdout,910) 'larger',rec_tim(lgind),x_tim(lgind)
# endif
            call exitus ('NEST_T_ALIGN')
         end if
c
      end if
#endif
#if defined usrdiagnostic & defined nesttime
# ifndef iforttime
      call dtime (tsn1)
# else
      dum = dtime (tsn1)
# endif
#endif
c
      return
c
 900  format (/'***Error:  NEST_T_ALIGN - time steps do NOT match'/11x,
     &        'time step (current domain): ',i10)
 910  format (/11x,'time step (',a,' domain): ',i10,',  expected: ',i10)
c
      end
