      subroutine reset_advect (iunit)
C
C=======================================================================
C                                                                    ===
C  This routine updates barotropic advection accounting for volume   ===
c  box changes from time TAU to time TAU+1. The internal velocities  ===
c  is  reset to vertically averaged zero mean for time TAU+1.        ===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data.
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <vertslabs.h>
#include <onedim.h>
#include <voldat.h>
#include <workspa.h>
#include <bndata.h>
#include <vertical.h>
#ifdef frozentrc
# include <fullwd.h>
#endif
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer nstr,nend
      parameter (nstr=nt*imtkm, nend=nstr+2*imtkm-1)
c
      integer i,ip,iunit,j,k,m,nrmb
      FLOAT
     &        dzwk,umz,vmz,fx
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
c-----------------------------------------------------------------------
c  Roll over all slabs
c-----------------------------------------------------------------------
c
#if !defined bioadjloc
      do 30 j = 2, jmtm2
        do 20 i = 2, imum1
           ip = i + (j-1)*imt
           do 10 k=1,km
# if !defined scaluvunflt
              xu(ip,k)=xu(ip,k) / fracv(i,j)
              xv(ip,k)=xv(ip,k) / fracv(i,j)
# else
              xu(ip,k)=xu(ip,k) / fracvuf(i,j)
              xv(ip,k)=xv(ip,k) / fracvuf(i,j)
# endif
  10       continue
  20    continue
  30  continue
#endif
#ifdef frozentrc
      if (itt.gt.ntdgn) then
#endif
        do 70 j = 2, jmtm2
          do 60 i = 2, imtm1
             ip = i + (j-1)*imt
             do 50 k=1,km
#if !defined bioadjvert & !defined bioadjloc
                do 40 m = 1, nt
#else
                do 40 m = 3, nt
#endif
#if !defined scaltsunflt
                   xt(ip,k,m) = xt(ip,k,m) / fract(i,j)
#else
                   xt(ip,k,m) = xt(ip,k,m) / fractuf(i,j)
#endif
  40            continue
  50         continue
  60      continue
  70    continue
#ifdef frozentrc
      endif
#endif
c
      return
      end


