      subroutine reset_ps (ptdonly)
c
c=======================================================================
c                                                                    ===
c  This subroutine calculates the zt=fac*Div(hhv [uvel,vvel])        ===
c                                                                    ===
c=======================================================================
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <fullwd.h>
#include <onedim.h>
#include <fields.h>
#include <workspb.h>
#if defined limpstshap & defined shapetalag
# include <scalar.h>
# include <vertical.h>
#endif
#if (defined scaluvunflt | defined scaltsunflt) & defined pfiltint
# include <filtdat.h>
#endif
c
c-----------------------------------------------------------------------
c  Define local variables and arrays.
c-----------------------------------------------------------------------
c
#ifdef dumppsrst
      integer dmptim
      parameter (dmptim=3)
      character*4 ittstr
#endif
      logical ptdonly
      FLOAT
     &        wk(imt,jmt)
      integer i,j,iend,istr,luptdb
#ifdef coast
      integer l
#endif
#if (defined scaluvunflt | defined scaltsunflt) & defined pfiltint
      integer iicntp,nn
      data iicntp /0/
      save iicntp
#endif
c
c-----------------------------------------------------------------------
c  Begin executable code.
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c  Replace change of surface pressure by divergences.
c-----------------------------------------------------------------------
c
      do 40 j=2,jmt-1
c
#ifdef coast
c
c  Choose to compute at sea points only and avoid land points
c
         do 30 l=1,lseg
            istr=isp(j,l)
            if(istr.eq.0) go to 40
            iend=iep(j,l)
#else
c
            istr=2
            iend=imt-1
#endif
            do 20 i=istr,iend
c
               ptd(i,j) = - ztd(i,j)
c
 20         continue
#ifdef coast
 30      continue
#endif
#ifdef cyclic
         ptd(1,j)   = ptd(imum1,j)
         ptd(imu,j) = ptd(2,j)
#endif
 40   continue
c
      if (ptdonly) return
c
      luptdb=6-mod(itt,2)
      call oput(kflds,nwds,(luptdb-1)*nwds+1,ptd)
c
c-----------------------------------------------------------------------
c  Update the surface pressure.
c-----------------------------------------------------------------------
c
      do 60 j = 1, jmt
         do 50 i = 1, imt
            wk(i,j)=pb(i,j)+ptd(i,j)
#if defined limpstshap & defined shapetalag
            etatbb(i,j)=pb(i,j)/grav
#endif
            pb(i,j)=p(i,j)
            p(i,j)=wk(i,j)
#if (defined scaluvunflt | defined scaltsunflt) & defined pfiltint
            punflt(i,j)=wk(i,j)
#endif
 50      continue
 60   continue
c
#if (defined scaluvunflt | defined scaltsunflt) & defined pfiltint
      iicntp=iicntp+1
      print *,'iicntp=',iicntp
      if(iicntp.eq.nfrqz2)then
        iicntp=0
        if(nordz2.gt.0)then
          do 640 nn=1,ntimz2
            call shap_lev(p,imt,jmt,pgrid,nordz2)
 640      continue
        endif
      endif
c
#endif
#ifdef dumppsrst
c-----------------------------------------------------------------------
c  Debugging dumping.
c-----------------------------------------------------------------------
c
c      if (itt.eq.dmptim) then
         write (ittstr,'(i4.4)') itt
         open (413, file='ztd2'//ittstr//'.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) ztd(i,j)
            enddo
         enddo
         close(413)
         open (413, file='ptd'//ittstr//'.dat', status='unknown')
         do j = 1, jmt
            do i = 1, imt
               write (413,*) ptd(i,j)
            enddo
         enddo
         close(413)
c      endif
c
#endif
      return
      end
