      subroutine rshap2d (nx,ny,ldfi,sdfi,fldin,ldfo,sdfo,fldout)
c
c=======================================================================
c                                                                    ===
c  This routine copies data from one 2d array into a second,         ===
c  differently shaped, 2d array.                                     ===
c                                                                    ===
c  ------                                                            ===
c  Input:                                                            ===
c  ------                                                            ===
c                                                                    ===
c     NX      Number of "x" elements to transfer.   (integer)        ===
c     NY      Number of "y" elements to transfer.   (integer)        ===
c     LDFI    Leading dimension of input array.     (integer)        ===
c     SDFI    Second dimension of input array.      (integer)        ===
c     FLDIN   Input array.                          (real array)     ===
c     LDFO    Leading dimension of output array.    (integer)        ===
c     SDFO    Second dimension of output array.     (integer)        ===
c                                                                    ===
c  -------                                                           ===
c  Output:                                                           ===
c  -------                                                           ===
c                                                                    ===
c     FLDOUT  Output array.                         (real array)     ===
c                                                                    ===
c  ------                                                            ===
c  Calls:                                                            ===
c  ------                                                            ===
c                                                                    ===
c     none                                                           ===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data.
c-----------------------------------------------------------------------
c
#include <cdefs.h>
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i,j,ldfi,ldfo,nx,ny,sdfi,sdfo
      FLOAT
     &      fldin(ldfi,sdfi),fldout(ldfo,sdfo)
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
      do 10 j = 1, ny
      do 10 i = 1, nx
         fldout(i,j) = fldin(i,j)
  10  continue
c
      return
      end
