      subroutine setup_smldtps (ttsecsave)
c
c-----------------------------------------------------------------------
c  Define global data.
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <dtswap.h>
#include <fields.h>
#include <fieldsbar.h>
#include <fullwd.h>
#include <scalar.h>
#include <vertical.h>
#include <workspb.h>
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i,j
      FLOAT
     &      ttsecsave
c
c-----------------------------------------------------------------------
c  Begin executable code.
c-----------------------------------------------------------------------
c
#if defined scaltsunflt | defined scaluvunflt
      do 5 j = 1, jmt
      do 5 i = 1, imt
# if !defined smldtscl
          punflt(i,j)=pb(i,j)+ptdsum(i,j)
# else
          punflt(i,j) =c0
          pbunflt(i,j)=c0
# endif
   5  continue
c
      if (npsrep.gt.1) then
#endif
c-----------------------------------------------------------------------
c Reset time for small dt.
c-----------------------------------------------------------------------
c
      ttsecsave = ttsec - dtts
c
#if defined ext_tide
c-----------------------------------------------------------------------
c Reset tidal data for small dt.
c-----------------------------------------------------------------------
c
c      write (6,*) '--------SETUP_SMLDTPS: setting tides-------------'
      ttsec = ttsecsave - dtsf
      call tid_bar_rset
c
      ttsec = ttsecsave
      call tid_bar_rset
c
#endif
c-----------------------------------------------------------------------
c Swap data for small dt calculation.
c-----------------------------------------------------------------------
c
      do 10, j = 1, jmt
      do 10, i = 1, imt
c
c Save barotropic velocities for large dt.
c
         ubarbuv(i,j) = ubarob(i,j)
         ubaruv(i,j)  = ubaro(i,j)
         vbarbuv(i,j) = vbarob(i,j)
         vbaruv(i,j)  = vbaro(i,j)
c
c Save surface pressure and tendancies for large dt.
c
         pbuv(i,j)   = pb(i,j)
         puv(i,j)    = p(i,j)
         ptdbuv(i,j) = ptdb(i,j)
         ptduv(i,j)  = ptd(i,j)
c
c Save surface elevation and stretching quantities for large dt.
c
         etatbuv(i,j)   = etatb(i,j)
         etatuv(i,j)    = etat(i,j)
         fractbuv(i,j)  = fractb(i,j)
         etavuv(i,j)    = etav(i,j)
c
c Load barotropic velocities for small dt.
c
         ubarob(i,j) = ubarbps(i,j)
         ubaro(i,j)  = ubarps(i,j)
         vbarob(i,j) = vbarbps(i,j)
         vbaro(i,j)  = vbarps(i,j)
c
c Load surface pressure and tendancies for small dt.
c
         pb(i,j)     = pbps(i,j)
         p(i,j)      = pps(i,j)
         ptdbsv(i,j) = ptdbps(i,j)
         ptd(i,j)    = ptdps(i,j)
c
c Load surface elevation and stretching for small dt.
c
         etatb(i,j)   = etatbps(i,j)
         etat(i,j)    = etatps(i,j)
         fractb(i,j)  = fractbps(i,j)
         etav(i,j)    = etavps(i,j)
c
c Initialize sum of surface pressure tendancies for small dt.
c
         ptdsum(i,j) = c0
  10  continue
#if defined scaltsunflt | defined scaluvunflt
c
      endif
#endif
c
      return
      end

