      subroutine setuvindx (mask,isuv,ieuv,jsuv,jeuv)
c
c=======================================================================
c                                                                    ===
c  This routine sets boundary indicators auxiliary arrays.           ===
c                                                                    ===
c  ------                                                            ===
c  Input:                                                            ===
c  ------                                                            ===
c                                                                    ===
c  MASK       mask for U or V point.                (integer array)  ===
c  ISUV       starting ocean x-index at UV-points.  (integer array)  ===
c                                                                    ===
c  -------                                                           ===
c  Output:                                                           ===
c  -------                                                           ===
c                                                                    ===
c  ISUV       starting ocean x-index at UV-points.  (integer array)  ===
c  IEUV       ending ocean x-index at UV-points.    (integer array)  ===
c  JSUV       starting ocean x-index at UV-points.  (integer array)  ===
c  JEUV       ending ocean x-index at UV-points.    (integer array)  ===
c                                                                    ===
c  Calls:     EXITUS  GETPBN                                         ===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data.
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <iounits.h>
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i,j,l,lsegp,n
      integer ieuv(jmt,lseg),isuv(jmt,lseg),jsuv(imt,lseg),
     &        jeuv(imt,lseg),mask(imt,jmt)
c
c=======================================================================
c  Begin executable code.
c=======================================================================
c
c-----------------------------------------------------------------------
c  Compute start and end indices at velocity points for filters.
c-----------------------------------------------------------------------
c
      do 10 n=1,lseg
      do 10 j=1,jmt
        isuv(j,n)=0
        ieuv(j,n)=0
  10  continue
c
      lsegp=lseg+1
c
      do 30 j=2,jmtm2
         l=1
         do 20 i=2,imum1
            if ((mask(i-1,j).eq.0).and.(mask(i,j).ne.0)) isuv(j,l)=i
#ifndef coast
            if (i.eq.2) isuv(j,l)=2
#else
            if ((i.eq.2).and.(mask(i-1,j).ne.0).and.(mask(i,j).ne.0))
     &         isuv(j,l)=i
#endif
            if ((mask(i,j).ne.0).and.(mask(i+1,j).eq.0)) then
               ieuv(j,l)=i
               l=l+1
            endif
#ifndef coast
            if ((i.eq.imum1).and.(mask(i+1,j).ne.0)) ieuv(j,l)=i
#else
            if((i.eq.imum1).and.(mask(i+1,j).ne.0).and.(mask(i,j).ne.0))
     &         ieuv(j,l)=i
#endif
            if (l.ge.lsegp) then
               write (stdout,900) 'JSEG = ',lsegp
               call exitus('SETUVINDX')
            endif
  20     continue
  30  continue
c
#ifdef coast
c-----------------------------------------------------------------------
c  Compute start and end indices at velocity points for filters.
c-----------------------------------------------------------------------
c
      do 40 n=1,lseg
      do 40 i=1,imt
         jsuv(i,n)=0
         jeuv(i,n)=0
  40  continue
c
      lsegp=lseg+1
c
      do 60 i=2,imum1
         l=1
         do 50 j=2,jmtm2
            if ((mask(i,j-1).eq.0).and.(mask(i,j).ne.0)) jsuv(i,l)=j
            if ((j.eq.2).and.(mask(i,j-1).ne.0).and.(mask(i,j).ne.0))
     &         jsuv(i,l)=2
            if ((mask(i,j).ne.0).and.(mask(i,j+1).eq.0)) then
              jeuv(i,l)=j
              l=l+1
            endif
            if((j.eq.jmtm2).and.(mask(i,j+1).ne.0).and.(mask(i,j).ne.0))
     &         jeuv(i,l)=j
            if(l.ge.lsegp) then
              write(stdout,900) 'ISEG = ',lsegp
              call exitus('SETUVINDX')
            endif
  50     continue
  60  continue
#endif
c
#ifdef sunflush
c-----------------------------------------------------------------------
c  Flush output buffers.
c-----------------------------------------------------------------------
c
      call flush(stdout)
c
#endif
 900  format(/' SETUVINDX - number of segments exceeded, ',a,i4)
c
      return
      end
