      subroutine shap_levb(zz,m,n,isra,iera,jsra,jera,nord)
c
c=======================================================================
c                                                                    ===
c  PE model version of the Shapiro Filter.                           ===
c                                                                    ===
c     Arguments:                                                     ===
c                                                                    ===
c     M       the size of first dimension of the array to filter     ===
c     N       the size of second dimension of the array to filter    ===
c     NORD    the order of the filter to apply                       ===
c     ZZ      the array to be filtered                               ===
c     KEY     grid type [t-grid or u-grid]                           ===
c                                                                    ===
c=======================================================================
c
c-----------------------------------------------------------------------
c  Define global data.
c-----------------------------------------------------------------------
c
#include <cdefs.h>
#include <param.h>
#include <pconst.h>
#include <options.h>
#include <iounits.h>
c
c-----------------------------------------------------------------------
c  Define local data.
c-----------------------------------------------------------------------
c
      integer i,idown,iup,icolb,icole,iend,ii,iodev,ip,istr,j,jend,jj,
     &        jrowb,jrowe,jstr,kord,m,n,nord,l
      integer isra(jmt,lseg),iera(jmt,lseg),jsra(imt,lseg),
     &        jera(imt,lseg)
      FLOAT
     &      fac,g(0:ijmx+1,0:1),zz(nwds)
c
c-----------------------------------------------------------------------
c  Begin excutable code.
c-----------------------------------------------------------------------
c
      iodev=(nord+1)/2-nord/2
      fac=cm1+c2*FLoaT(iodev)
      fac=fac/c2**(2*nord)
c
c  Set default bdy condition 
c
      jrowb=1
      icolb=1
      jrowe=n
      icole=m
      iup=1
c
c  Filter by rows.
c
      do 60 j=jrowb,jrowe
        ip=(j-1)*imt
      do 55 l=1,lseg
        istr=isra(j,l)
        if(istr.eq.2)istr=1
        if(istr.eq.0) goto 60
        iend=iera(j,l)
        if(iend.eq.imum1)iend=imu
        if(istr.ge.iend) goto 55
        ii=0
        g(ii,iup)=zz(ip+istr+1)
        do 10 i=istr,iend
          ii=ii+1
          g(ii,iup)=zz(ip+i)
  10    continue
        g(ii+1,iup)=zz(ip+iend-1)
        do 40 kord=1,nord
          idown=1-iup
          do 20 i=1,ii
            g(i,idown)=cm2*g(i,iup)+g(i+1,iup)+g(i-1,iup)
  20      continue
          iup=1-iup
          g(0,iup)=g(2,iup)
          g(ii+1,iup)=g(ii-1,iup)
  40    continue
        ii=0
        do 50 i=istr,iend
          ii=ii+1
          zz(ip+i)=zz(ip+i)+fac*g(ii,iup)
  50    continue
  55  continue
  60  continue
c
c  Filter by columns.
c
      do 120 i=icolb,icole
      do 115 l=1,lseg
        jstr=jsra(i,l)
        if(jstr.eq.2)jstr=1
        if(jstr.eq.0) goto 120
        jend=jera(i,l)
        if(jend.eq.jmtm1-1)jend=jmtm1
        if(jstr.ge.jend) goto 115
        jj=0
        g(jj,iup)=zz((jstr)*imt+i)
        do 70 j=jstr,jend
          jj=jj+1
          ip=(j-1)*imt+i
          g(jj,iup)=zz(ip)
  70    continue
        g(jj+1,iup)=zz((jend-2)*imt+i)
        do 100 kord=1,nord
          idown=1-iup
          do 80 j=1,jj
            g(j,idown)=cm2*g(j,iup)+g(j+1,iup)+g(j-1,iup)
  80      continue
          iup=1-iup
          g(0,iup)=g(2,iup)
          g(jj+1,iup)=g(jj-1,iup)
 100    continue
        jj=0
        do 110 j=jstr,jend
          jj=jj+1
          ip=(j-1)*imt+i
          zz(ip)=zz(ip)+fac*g(jj,iup)
 110    continue
 115  continue
 120  continue
      return
      end
