c
c=======================================================================
c  Include file "sinfo.h"
c=======================================================================
#ifndef rmdocinc
c
c  ZUM        Vertically averaged forcing for U Baro equation.
c  ZVM        Vertically averaged forcing for V Baro equation.
c  UBARHAT    Augmented U velocity obtained from operator splitting.
c  VBARHAT    Augmented V velocity obtained from operator splitting. 
#if defined freesurf & defined lagnonlin
c  UCLSF      Zonal baroclinic velocity at surface
c  VCLSF      Meridional baroclinic velocity at surface
#endif
c  ALPHAV     Time biasing velocity constant of S & D numerical scheme.
c  ALPHAP     Time biasing pressure constant of S & D numerical scheme.
c  ALPHAV2    2*alphav
c  ALPHAP2    2*alphap
c  GAMMABAR   Composite constant for velocity in S & D scheme.
c  GAMMABARP  Composite constant for pressure in S & D scheme.
c  THETASD    Constant to time bias transport in free surface.
c=======================================================================
#endif
c
      FLOAT 
     &      zum(imt,jmt),zvm(imt,jmt),zumb(imt,jmt),zvmb(imt,jmt),
     &      ubarhat(imt,jmt),vbarhat(imt,jmt)
#if defined freesurf & (defined lagnonlin | defined tidepredctr)
     &      ,uclsf(imt,jmt),vclsf(imt,jmt)
#endif
      FLOAT 
     &      alphav,alphap,alphav2,alphap2,gammabar,gammabarp,
     &      thetasd,c2dtps
c
      common /fsinfo/ zum,zvm,zumb,zvmb,ubarhat,vbarhat
#if defined freesurf & (defined lagnonlin | defined tidepredctr)
     &                ,uclsf,vclsf
#endif
      common /csinfo/ alphav,alphap,alphav2,alphap2,gammabar,gammabarp,
     &              thetasd,c2dtps

